package com.ccwangluo.im.adapter;


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.ccwangluo.ccim.data.PushPrivateMsgRes;
import com.ccwangluo.im.R;

import java.util.List;

public class PrivateMsgAdapter extends BaseAdapter {

    private List<PushPrivateMsgRes.MessageDTO> dataList;

    private Context context;

    public PrivateMsgAdapter(List<PushPrivateMsgRes.MessageDTO> dataList, Context context) {
        this.dataList = dataList;
        this.context = context;
    }

    /**
     * Provide a reference to the type of views that you are using
     * (custom ViewHolder).
     */
    public static class ViewHolder {
        public TextView msg_content;
        public TextView msg_content_send;

    }

    @Override
    public int getCount() {
        return dataList.size();
    }

    @Override
    public Object getItem(int position) {
        return dataList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        ViewHolder mHolder;
        if (convertView == null) {
            mHolder = new ViewHolder();
            LayoutInflater inflater = LayoutInflater.from(context);
            convertView = inflater.inflate(R.layout.msg_row_item, null, true);
            mHolder.msg_content = convertView.findViewById(R.id.msg_content);
            mHolder.msg_content_send = convertView.findViewById(R.id.msg_content_send);
            convertView.setTag(mHolder);
        } else {
            mHolder = (ViewHolder) convertView.getTag();
        }
        PushPrivateMsgRes.MessageDTO messageDTO = dataList.get(position);
        if (messageDTO.getSenderUserId() != null) {
            mHolder.msg_content.setVisibility(View.VISIBLE);
            mHolder.msg_content_send.setVisibility(View.GONE);
            mHolder.msg_content.setText(messageDTO.getContent());
        } else if (messageDTO.getReciveUserId() != null){
            mHolder.msg_content.setVisibility(View.GONE);
            mHolder.msg_content_send.setVisibility(View.VISIBLE);
            mHolder.msg_content_send.setText(messageDTO.getContent());
        }
        return convertView;
    }

    public void refreshData(){
        notifyDataSetChanged();
    }
}

