package com.ccwangluo.im.ui.dashboard;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.ccwangluo.ccim.CCIMClient;
import com.ccwangluo.ccim.data.Contact;
import com.ccwangluo.ccim.data.PushPrivateMsgRes;
import com.ccwangluo.ccim.listener.ResultCallback;
import com.ccwangluo.ccim.util.MediaHelper;
import com.ccwangluo.im.adapter.PrivateMsgAdapter;
import com.ccwangluo.im.data.LoginViewModel;
import com.ccwangluo.im.databinding.FragmentConnectBinding;

import java.util.ArrayList;
import java.util.List;

public class ConnectFragment extends Fragment {
    private FragmentConnectBinding binding;
    private LoginViewModel loginViewModel;
    private PrivateMsgAdapter privaetMsgAdapter;
    private List<PushPrivateMsgRes.MessageDTO> list = new ArrayList<>();
    private String filePath;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentConnectBinding.inflate(inflater, container, false);
        loginViewModel = new ViewModelProvider(getActivity())
                .get(LoginViewModel.class);

        privaetMsgAdapter = new PrivateMsgAdapter(list,getContext());

        binding.msgList.setAdapter(privaetMsgAdapter);

        Contact contact = (Contact) getArguments().getSerializable("contact");

        loginViewModel.privateMsgList.observe(getViewLifecycleOwner(), new Observer<List<PushPrivateMsgRes>>() {
            @Override
            public void onChanged(List<PushPrivateMsgRes> pushPrivateMsgRes) {
                list.clear();
                for (PushPrivateMsgRes pushPrivateMsgRe : pushPrivateMsgRes) {
                    if ((contact.getContactUserId().equals(pushPrivateMsgRe.getMessage().getSenderUserId())|| contact.getContactUserId().equals(pushPrivateMsgRe.getMessage().getReciveUserId()))) {
                        list.add(pushPrivateMsgRe.getMessage());
                    }
                }
                privaetMsgAdapter.refreshData();
                binding.msgList.setSelection(privaetMsgAdapter.getCount() - 1);
            }
        });

        binding.sendBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String content = binding.sendEdit.getText().toString();
                CCIMClient.getInstance().sendTextMessage(content, contact.getContactUserId(), new ResultCallback() {
                    @Override
                    public void onSuccess() {
                        binding.sendEdit.setText("");
                        PushPrivateMsgRes.MessageDTO messageDTO = new PushPrivateMsgRes.MessageDTO();
                        messageDTO.setReciveUserId(contact.getContactUserId());
                        messageDTO.setContent(content);
                        PushPrivateMsgRes pushPrivateMsgRes = new PushPrivateMsgRes();
                        pushPrivateMsgRes.setMessage(messageDTO);
                        loginViewModel.addPrivateMsg(pushPrivateMsgRes);
                        Toast.makeText(getContext(),"send Success",Toast.LENGTH_LONG).show();
                    }
                });
            }
        });

        binding.sendVoice.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if(event.getAction() == MotionEvent.ACTION_UP){
                    CCIMClient.getInstance().stopAndSendAudioMessage();
                }
                if(event.getAction() == MotionEvent.ACTION_DOWN){
                   CCIMClient.getInstance().startRecordAudioMessage(getActivity());
                }

                return false;
            }
        });

        binding.playVoice.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().startPlayAudio(MediaHelper.getInstance().getFilePath());
            }
        });
        return binding.getRoot();
    }
}